#include "huhfa.h"

//Find-subroutine of Disjoint Set Datastructure ("DSD")
int getClass(int a, vector<pair<int,int> > &C){
    if(C[a].first!=a){
        C[a].first=getClass(C[a].first,C);
    }
    return C[a].first;
}

void huhfa::classify(bool complete){
    if(!input_fail){
        //Every Facet is assigned to its own class (Makeset of "DSD")
        Facet_to_Class.clear();
        for(int i=0; i<f; i++){
            Facet_to_Class.push_back(make_pair(i,0));
        }

        vector<bool> Image;
        int Image_Index;
        //Every Facet gets its Incidence Vector permutated
        for(int i=0; i<f; i++){
            if(!complete || Facet_to_Class[i].first==i){
                for(int j=0; j<p; j++){
                    //Compute the Image of the incidence Vector under the permutation
                    Image.clear();
                    for(int k=0; k<v; k++){
                        Image.push_back(Index_to_Incidence[i][Permutations_Table[j][k]]);
                    }
                    //If the Image corresponds to another facet
                    if( (Incidence_to_Index.find(Image))!=Incidence_to_Index.end()){
                        //Find the class of that facet
                        Image_Index=Incidence_to_Index[Image];
                        //Assign both facets the same class (Union of "DSD")
                        int Image_class=getClass(Image_Index,Facet_to_Class);
                        int i_class=getClass(i,Facet_to_Class);
                        if(i_class!=Image_class){
                            if(Facet_to_Class[i_class].second < Facet_to_Class[Image_class].second){
                                Facet_to_Class[i_class].first=Facet_to_Class[Image_class].first;
                            }
                            else if(Facet_to_Class[i_class].second > Facet_to_Class[Image_class].second){
                                Facet_to_Class[Image_class].first=Facet_to_Class[i_class].first;
                            }
                            else{
                                Facet_to_Class[Image_class].first=Facet_to_Class[i_class].first;
                                Facet_to_Class[i_class].second+=1;
                            }
                        }
                    }
                    else{
                        cerr<<"Error: The facet defined by"<<endl;
                        for(int k=0; k<n; k++){
                            if( inequalities[i][k]!=0 ){
                                if( inequalities[i][k]>0 ){
                                    cerr<<"+";
                                }
                                if(inequalities[i][k]==-1){
                                    cerr<<"- ";
                                }
                                else if(inequalities[i][k]!=1){
                                    cerr<<inequalities[i][k];
                                }
                                else{
                                    cerr<<" ";
                                }
                                cerr<<" "<<variables[k]<<" ";
                            }
                        }
                        cerr<<"<= "<<inequalities[i][n]<<endl;
                        cerr<<"is not mapped to another facet by a symmetry "<<j<<"."<<endl;
                    }
                }
            }
        }
        int order;
        for(int i=0; i<f; i++){
            getClass(i,Facet_to_Class);
            order=0;
            for(int j=0; j<v; j++){
                order+=Index_to_Incidence[i][j];
            }
            classes[order][Facet_to_Class[i].first].push_back(i);
        }
    }
}

